#include <windows.h>
#include "dbx_utils.h"

int main()
{
  // Load the list of identities on this machine
  dbx_EnsureStores();
  if (dbx_Stores.size()==0) {printf("No Outlook Express identities\n"); return 0;}
  printf("Identity: user=%s version=%s path=%s\n", dbx_Stores[0].name.c_str(), dbx_Stores[0].ver.c_str(), dbx_Stores[0].path.c_str());

  // Load the list of folders in the first identity
  string ffn; // we'll remember the first normal folder we find, to enumerate its messages
  dbx_EnsureFolders(dbx_Stores[0].name, dbx_Stores[0].ver);
  printf("%i folders\n",dbx_Folders.size());
  for (vector<TDbxFolderInfo>::const_iterator i=dbx_Folders.begin(); i!=dbx_Folders.end(); i++)
  { if (i->type==dftMail && ffn.length()==0) ffn=i->fpath+"\\"+i->fn;
    printf("%s\n",i->full.c_str());
  }
  if (dbx_Folders.size()==0) return 0;

  // Work through all the messages in the first folder
  printf("\nFolder %s:\n",ffn.c_str());
  imemfile inm(ffn.c_str());
  if (!inm.okay()) return 0;
  DbxFileHeader fileHeader(inm);
  int4 address = fileHeader.GetValue(fhTreeRootNodePtr);
  int4 entries = fileHeader.GetValue(fhEntries);
  if (address==0 || entries==0) return 0;
  //
  DbxTree tree(inm,address,entries); // Read in the tree with pointers to each message
  for(int4 j=0; j<entries; ++j) // cycle through messages
  { address = tree.GetValue(j);
    DbxMessageInfo messageInfo(inm,address);
    int4 messageAddress = messageInfo.GetValue(miiMessageAddress);
    // Get message headers and text
    int4 length;
    char *cto=(char*)messageInfo.GetValue(19,&length);
    char *cfrom=(char*)messageInfo.GetValue(13,&length);
    char *csub=(char*)messageInfo.GetValue(5,&length);
    char *ctext=0; unsigned int ctextlen=0;
    if (messageAddress!=0)
    { DbxMessage message(inm, messageAddress);
      ctext=message.GetText(); ctextlen=message.GetLength();
    }
    //
    printf("%s from:%s to:%s\n",csub,cfrom,cto);
  }

  inm.close();
  
  return 0;
}
